#include <OneWire.h>
#include <LiquidCrystal.h>
#include <DallasTemperature.h>
#include <BMP085.h>
#include <Wire.h>
#include <EEPROM.h>
#define pin_X 6                                  // Ось Х подключена к Analog 2
#define pin_Y 7                                  // Ось Y подключена к Analog 3
#define pin_Z 14                                  // Ось Z (кнопка джойстика) подключена к Analog 0
LiquidCrystal lcd(4, 5, 10, 11, 12, 13);         // Пины дисплея
OneWire oneWire(8);
DallasTemperature sensors(&oneWire);
DeviceAddress Therm1 = {                   // Термометр температуры куба
  0x28, 0x4E, 0xF5, 0x55, 0x06, 0x00, 0x00, 0x84 // адрес термоментра в кубе, вставляете свой иначе температуру показывать не будет
                             }; 
DeviceAddress Therm2 = {                   // Термометр температуры дистиллятора
  0x28, 0xCF, 0xC6, 0xD2, 0x05, 0x00, 0x00, 0x28 // адрес термоментра в дистилляторе, вставляете свой иначе температуру показывать не будет
                             }; 
                             
// Переменные для джойстика
  int X, Y, Z = 0;                                // Переменные для хранения значений осей
  int S=0;                                        // Номер основного экрана
  int M=0;                                        // Переменная нахождения в режиме меню или на основном экране
  int P=0;                                        // Номер пункта меню
  int R=0;                                        // Переменная разрещения или запрета на редактирование
// Основные параметры
  BMP085 dps = BMP085();
  long Temperature = 0, Pressure = 0, Altitude = 0;
  float Tvoda = 84.5;                             // Начальная уставка температуры в кубе когда включать воду пищит пищалка
  byte TS = 30;                                 // Начальное значение времени пищания пищалки в мсек (30 сек)
  float Tstop = 98.5;                             // Начальная уставка температуры окончания процесса, отключении нагрева и воды, пищит пищалка
  float Kstop = 15;                               // Начальная уставка крепости погона для окончания процесса, пищит пищалка
  float Kstopmin = 0;                             // Минимальная крепость
  float Kstopmax = 100;                           // Максимальная крепость
  float Tmin=75.0;                                // Минимальная температура
  float Tmax=101.0;                               // Максимальная температура
  float d = 0.1;                                  // Шаг изменения температуры
  byte E=0;                                        // Если вы используете датчик переполнения емкости оставьте 1, если не используете поставьте 0, иначе будет постоянно орать.
  byte W=0;                                        // Если вы используете датчик протечки воды оставьте 1, если не используете поставьте 0, иначе будет постоянно орать.
  byte A=0;                                        // Если установить 0 - то заканчивать дистилляцию по температуре Tstop, если установить 1 - то оканчивать дистилляцию по достижениее указанной крепости Kstop 
  byte F=0;                                        // Текущий режим диапозона температуры
  byte B=1;                                        // Состояние звука, 1-вкл, 0-выкл НЕ МЕНЯТЬ ИНАЧЕ ЗВУК БУДЕТ РАБОТАТЬ НЕККОРЕКТНО
  byte P1=0;
  byte P2=0;
  float Pr=0;                                     // Текущее атмосферное давление
  float dT=0;                                     // Поправка температуры при изменении давления
  float dP=0;                                     // Разница между текущим давлением и 760 мм рт ст
  float Tp=0;                                     // Температура в помещении с датчика давления
  char V[]="V2.0";                                // Версия скетча
  float dTD78_81=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 78-81*C, например делаем контрольное измерение крепости при температуре 79,5*С, если датчик показывает правильно оставляем 0, значение может быть положительным или отрицательным, разделитель между целыми и десятыми точка (.)
  float dTD81_84=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 81-84*C, замер крепости при 82,5*C
  float dTD84_87=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 84-87*C, замер крепости при 85,5*C
  float dTD87_90=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 87-90*C, замер крепости при 88,5*C
  float dTD90_91=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 90-91*C, замер крепости при 90,5*C
  float dTD91_92=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 91-92*C, замер крепости при 91,5*C
  float dTD92_93=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 92-93*C, замер крепости при 92,5*C
  float dTD93_94=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 93-94*C, замер крепости при 93,5*C
  float dTD94_95=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 94-95*C, замер крепости при 94,5*C
  float dTD95_96=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 95-96*C, замер крепости при 95,5*C 
  float dTD96_97=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 96-97*C, замер крепости при 96,5*C
  float dTD97_98=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 97-98*C, замер крепости при 97,5*C
  float dTD98_99=0;                               // Коррекция датччка температуры дистиллятора в диапозоне 98-99*C, замер крепости при 98,5*C
  float dTD99_100=0;                              // Коррекция датччка температуры дистиллятора в диапозоне 99-100*C, замер крепости при 99,5*C
  float dTDmin=-5.0;
  float dTDmax=5.0;
  float K1=0;                                     //Временный параметр для рассчета крепости кубового остатка
  float K3=0;                                     //Временный параметр для рассчета крепости в погоне
  float dT0=0;                                    //Временная переменная для хранения температуры в момент редактирования
  byte dC=0;                                       //Временная переменная для хранения целочисленных переменных  в момент редактирования
  byte Q=0;                                        //Признак активации таймера
  int Q2=0;                                       //Признак активации таймера 2
  unsigned long time;                             //Переменная для хранения времени
  unsigned long time2;                            //Переменная для хранения времени 2

// Массив температур для расчета крепости в дистилляторе
int T[198] = {782, 784, 786, 788, 790, 792, 794, 796, 798, 800, 802, 804, 806, 808, 810, 812, 814, 816, 818, 819, 820, 821, 822, 823, 824, 825, 826, 827, 828, 829, 830, 831, 832, 833, 834, 835, 836, 837, 838, 839, 840, 841, 842, 843, 844, 845, 846, 847, 848, 849, 850, 851, 852, 853, 854, 855, 856, 857, 858, 859, 860, 861, 862, 863, 864, 865, 866, 867, 868, 869, 870, 871, 872, 873, 874, 875, 876, 877, 878, 879, 880, 881, 882, 883, 884, 885, 886, 887, 888, 889, 890, 891, 892, 893, 894, 895, 896, 897, 898, 899, 900, 901, 902, 903, 904, 905, 906, 907, 908, 909, 910, 911, 912, 913, 914, 915, 916, 917, 918, 919, 920, 921, 922, 923, 924, 925, 926, 927, 928, 929, 930, 931, 932, 933, 934, 935, 936, 937, 938, 939, 940, 941, 942, 943, 944, 945, 946, 947, 948, 949, 950, 951, 952, 953, 954, 955, 956, 957, 958, 959, 960, 961, 962, 963, 964, 965, 966, 967, 968, 969, 970, 971, 972, 973, 974, 975, 976, 977, 978, 979, 980, 981, 982, 983, 984, 985, 986, 987, 988, 989, 990, 991, 992, 993, 994, 995, 996, 997};
// Массив крепостей для расчета крепости в дистилляторе
int K[198] = {9688, 9513, 9366, 9274, 9181, 9087, 8981, 8887, 8783, 8716, 8661, 8604, 8562, 8523, 8479, 8436, 8391, 8344, 8293, 8264, 8236, 8213, 8189, 8167, 8150, 8128, 8109, 8097, 8081, 8054, 8037, 8023, 8007, 7993, 7978, 7963, 7951, 7938, 7921, 7904, 7887, 7872, 7847, 7829, 7812, 7797, 778, 7761, 7739, 7716, 7694, 7671, 7644, 7617, 7592, 7568, 7541, 7517, 7489, 7460, 7434, 7407, 7379, 7352, 7325, 7297, 7270, 7245, 7219, 7193, 7168, 7141, 7116, 7088, 7063, 7035, 7005, 6973, 6943, 6914, 6888, 6859, 6831, 6802, 6769, 6737, 6709, 6682, 6654, 6626, 6598, 6571, 6544, 6513, 6486, 6449, 6413, 6377, 6339, 6301, 6267, 6233, 6203, 6168, 6132, 6097, 6065, 6028, 5996, 5958, 5922, 5889, 5858, 5822, 5791, 5758, 5727, 5690, 5657, 5627, 5595, 5560, 5527, 5500, 5465, 5431, 5397, 5366, 5317, 5287, 5265, 5232, 5200, 5176, 5142, 5106, 5070, 5034, 4998, 4970, 4921, 4861, 4800, 4738, 4672, 4632, 4618, 4597, 4576, 4554, 4527, 4478, 4442, 4393, 4345, 4296, 4246, 4195, 4143, 4104, 4052, 4000, 3946, 3892, 3836, 3796, 3740, 3681, 3623, 3565, 3507, 3444, 3395, 3329, 3263, 3196, 3129, 3061, 2991, 2940, 2869, 2798, 2705, 2588, 2472, 2354, 2225, 2067, 1933, 1792, 1647, 1470, 1316, 1166, 1014, 878, 788, 591};
// спецсимвол градус
  byte gradus[8] = 
  {
   B01100, B10010, B10010, B01100, B00000, B00000, B00000, B00000,
  };
// спецсимвол динамик
  byte sound[8] = 
  {
   B00001, B00011, B01111, B01111, B01111, B00011, B00001, B00000,
  };
// спецсимвол звук включен
  byte soundon[8] = 
  {
   B00100, B10010, B01001, B00101, B01001, B10010, B00100, B00000,
  };
// спецсимвол звук выключен
  byte soundoff[8] = 
  {
   B00000, B10001, B01010, B00100, B01010, B10001, B00000, B00000,
  };
// спецсимвол стрелка вверх
  byte up[8] = 
  {
   B00100, B01110, B10101, B00100, B00100, B00100, B00100, B00100,
  };
// спецсимвол стрелка вниз
  byte down[8] = 
  {
   B00100, B00100, B00100, B00100, B00100, B10101, B01110, B00100,
  };
//Для экономии памяти 
 void LCD()
 {
  lcd.begin(16, 2);
  lcd.setCursor(0, 0);
 }
//Процедура отсчета времени для выхода на основной экран в случае бездействия
 void exit()
 { 
  if(Q==0)
   {
    Q=1;
    time=millis();
    }
  if(X>400 && X<600 && Y>400 && Y<600 && Z==0 && R==0)
   {
    if(millis()-time>10000)
     {
      S=0;
      Q=0; 
      M=0;
      P=0;
     }
    }
   else
    {
     time=millis();
    }
  }
 void nosound()
  {
    if(Q2==0 && F!=2)
     {
       Q2=1;
       time2=millis();
     }
    if(F==1)
     {
      if(millis()-time2>TS*1000)
       {
        F=2;
        Q2=0;
        if (P1==0)
         {
          B=1;
          P1=1;
         }
       }
     }
    else
     {
      time2=millis();
     }
  } 
//Процедура записи параметров в еепром
 void eeprom()
 {
//Запись первоначальных параметров в еепром
  EEFW(0, Tvoda);
  EEPROM.write(4, TS);
  EEFW(8, Tstop);
  EEFW(12, dTD78_81);
  EEFW(16, dTD81_84);
  EEFW(20, dTD84_87);
  EEFW(24, dTD87_90);
  EEFW(28, dTD90_91);
  EEFW(32, dTD91_92);
  EEFW(36, dTD92_93);
  EEFW(40, dTD93_94);
  EEFW(44, dTD94_95);
  EEFW(48, dTD95_96);
  EEFW(52, dTD96_97);
  EEFW(56, dTD97_98);
  EEFW(60, dTD98_99);
  EEFW(64, dTD99_100);
  EEPROM.write(68, Kstop);
  EEPROM.write(69, E);
  EEPROM.write(70, W);
  EEPROM.write(71, A);
 }
       
//Процедура редактирования параметров 1
  void edit1()
   {
    if(Y < 400)
     {
      dT0=dT0+d;
      if(dT0 >= Tmax)
       {
        dT0=Tmax;
        }
       }
        if(Y > 600)
         {
          dT0=dT0-d;
          if(dT0 <= Tmin)
           {
            dT0=Tmin;
            }
           }
        }
        
//Процедура редактирования параметров 2
  void edit2()
   {
    if(Y < 400)
     {
      dT0=dT0+d;
      if(dT0 >= dTDmax)
       {
        dT0=dTDmax;
        }
       }
        if(Y > 600)
         {
          dT0=dT0-d;
          if(dT0 <= dTDmin)
           {
            dT0=dTDmin;
            }
           }
        }
        
//Процедура редактирования параметров 3
 void edit3()
  {
    if(Y < 400)
     {
      dC=1;
     }
    if(Y > 600)
     {
      dC=0;
     }
  }    
//Процедура вывода на экран части текста
  void ekran()
   {
     lcd.print(dT0,1);
     lcd.setCursor(0, 1);
     lcd.print("edit \5\7");
    }

     
//Процедура записи в еепром числа с плавающей точкой
  void EEFW(int addr, float val) 
       { 
	byte *x = (byte *)&val;
	for(byte i = 0; i < 4; i++) EEPROM.write(i+addr, x[i]);
       }
       
//Процедура чтения из еепром числа с плавающей точкой
  float EEFR(int addr) // чтение из ЕЕПРОМ
       {   
	  byte x[4];
	  for(byte i = 0; i < 4; i++) x[i] = EEPROM.read(i+addr);
	  float *y = (float *)&x;
	  return y[0];
	}  
  
 void setup() 
 { 
   LCD();
   pinMode(9, OUTPUT);                        // 9 пин отвечает за яркость информации 
   analogWrite(9, 100);                       // на дисплее, можно установить свою вместо 100
   pinMode(2,INPUT);
   digitalWrite(14, 1);                    //включаем на нем подтягивающий резистор
   Z = digitalRead(pin_Z);                    // Читаем нажата ли кнопка на джойстике
   Z = Z ^ 1;                                 // Инвертируем сигнал нажатия кнопки джойстика
   sensors.begin();
// Устанавливаем точность измерения термометров в 0,0625*С, отображение на дисплее все равно ведется с округлением до десятых, а в расчетах эта точность
   sensors.setResolution(Therm1, 12);
   sensors.setResolution(Therm2, 12);
// Заставка с названием программы и номером версии 3 сек
   LCD();
   lcd.print("Helper for");
   lcd.setCursor(0, 1);
   lcd.print("Distiller ");
   lcd.print(V);
   delay(3000);
// При нажатии кнопки на джойстике во время заставки, в еепром записываются значения по-умолчанию.
   if(Z==1)
   {
     eeprom();
     Z=0;
     LCD();
     lcd.print("3anucb 3akoH4eHa");
     delay(3000);
   }
// Читаем из еепрома параметры для редактирования   
   Tvoda = EEFR(0);
   TS = EEPROM.read(4);
   Tstop = EEFR(8);
   dTD78_81 = EEFR(12);
   dTD81_84 = EEFR(16);
   dTD84_87 = EEFR(20);
   dTD87_90 = EEFR(24);
   dTD90_91 = EEFR(28);
   dTD91_92 = EEFR(32);
   dTD92_93 = EEFR(36);
   dTD93_94 = EEFR(40);
   dTD94_95 = EEFR(44);
   dTD95_96 = EEFR(48);
   dTD96_97 = EEFR(52);
   dTD97_98 = EEFR(56);
   dTD98_99 = EEFR(60);
   dTD99_100 = EEFR(64);
   Kstop = EEPROM.read(68);
   E = EEPROM.read(69);
   W = EEPROM.read(70);
   A = EEPROM.read(71);
 }
 void loop() 
 { 
   Wire.begin();
   sensors.requestTemperatures();
   dps.init(MODE_ULTRA_HIGHRES, 0, true); 
   dps.getPressure(&Pressure);                        // Читаем давление с датчика давления
   dps.getTemperature(&Temperature);                  // Читаем температуру с датчика давления
   LCD();                                             // Инициализация дисплея
   lcd.createChar(1, gradus);
   float TempK1 = sensors.getTempC(Therm1);     // Читаем температуру датчика куба
   float TempD1 = sensors.getTempC(Therm2);     // Читаем температуру датчика дистиллятора
   float T1 = 0;  
   float K1 = 0;                                       // Крепость кубового остатка
   float K2 = 0;                                       // Крепость пара в дистилляторе
   float TempD2 = TempD1;
   float TempD3 = TempD2;
   Pr=Pressure/133.3;                                 // Переводим давление из паскалей в мм рт ст
   dP=Pr-760;                                         // Расчитываем разницу давлений между нормой 760 мм и текущим
   dT=0.035*dP;                                       // Расчитываем поправку к температуре исходя из давления
   Tp=Temperature*0.1;                                // Температура в помещении
//Вносим поправку температуры в разных температурных диапозонах для более точного определения крепости
  if(S==0)
   {
   if (TempD1>=78 && TempD1<81)
    {
     TempD2 = TempD1+dTD78_81;
    }
   if (TempD1>=81 && TempD1<84)
    {
     TempD2 = TempD1+dTD81_84;
    }
   if (TempD1>=84 && TempD1<87)
    {
     TempD2 = TempD1+dTD84_87;
    }
   if (TempD1>=87 && TempD1<90)
    {
     TempD2 = TempD1+dTD87_90;
    }
   if (TempD1>=90 && TempD1<91)
    {
     TempD2 = TempD1+dTD90_91;
    }
   if (TempD1>=91 && TempD1<92)
    { 
     TempD2 = TempD1+dTD91_92;
    }
   if (TempD1>=92 && TempD1<93)
    {
    TempD2 = TempD1+dTD92_93;
    }
   if (TempD1>=93 && TempD1<94)
    {
     TempD2 = TempD1+dTD93_94;
    }
   if (TempD1>=94 && TempD1<95)
    {
     TempD2 = TempD1+dTD94_95;
    }
   if (TempD1>=95 && TempD1<96)
    {
     TempD2 = TempD1+dTD95_96;
    }
   if (TempD1>=96 && TempD1<97)
    {
     TempD2 = TempD1+dTD96_97;
    }
   if (TempD1>=97 && TempD1<98)
    {
     TempD2 = TempD1+dTD97_98;
    }  
   if (TempD1>=98 && TempD1<99)
    {
     TempD2 = TempD1+dTD98_99;
    }
   if (TempD1>=99 && TempD1<100)
    {
     TempD2 = TempD1+dTD99_100;
    }
   }
// Вычислитель остаточной крепости в кубе
  if (TempK1 > 78.1)
   {
// Приближение до восьмой степени, для использованя раскомментируйте 2 строчки ниже и закоментируйте 2 строчки 4 степени приближения.
// T1 = (TempK1 - dT - 89)/6.49; 
// K1= 17.26 - 18.32*T1 + 7.81*sq(T1) - 1.77*pow(T1,3) + 4.81*pow(T1,4) - 2.95*pow(T1,5) - 1.43*pow(T1,6) + 0.8*pow(T1,7) + 0.05*pow(T1,8);
// Приближение до 4 степени
   T1 = (TempK1-dT-89.03)/6.54; 
   K1 = 16.75-19.05*T1+12.64*sq(T1)-3.69*pow(T1,3)-0.38*pow(T1,4);
   }
   TempD3 = TempD2 + dT;                              // Вносим поправку температуры от давления
// Вычисляем крепость пара в дистилляторе
    int TempD4=TempD3*10;
    if (TempD4>=T[0] && TempD4<T[197])
    {
    byte n=0;
    do
    { n=n+1;
    } while (TempD4>T[n]);
    float K21=K[n];
    float K22=K[n+1];
    float T21=T[n];
    float T22=T[n+1];
    float TempD5=TempD4;
    K2 = (K21+(K22-K21)*(TempD5-T21)/(T22-T21))/100;
    }   
// Работа джойстика
   X = analogRead(pin_X);                             // Читаем положение джойстика по оси X
   Y = analogRead(pin_Y);                             // Читаем положение джойстика по оси Y
   Z = digitalRead(pin_Z);                            // Читаем нажата ли кнопка на джойстике
   Z = Z ^ 1;                                     // Инвертируем сигнал нажатия кнопки джойстика
   if (M==0)
    {
     if(X<400)                                   // Джойстик влево
     {
      S=S-1;
      if(S<0)
       {
        S=2;
       }
      }
     if(X>600)                                    //Джойстик вправо
      {
       S=S+1;
       if(S>2)
        {
         S=0;
        }
       }
      }                                      //Процедура выбора экрана
  
// Проверка заполнения емкости
  if(E==1)
    {
    if(digitalRead(6)==LOW)
     {
      S=3;
      M=0;
     }
    } 
// Проверка разлития жидкости на полу
  if(W==1)
    {
    if(digitalRead(3)==LOW)
     {
      S=4;
      M=0;
     }
    } 
// Проверка работы датчика Ткуба
 if(TempK1<-100 && TempD1>0)
  {
   S=5;
   M=0; 
  }
// Проверка работы датчика Тдистил
 if(TempD1<-100 && TempK1>0)
  {
   S=6;
   M=0; 
  }
// Проверка работы датчиков температуры
 if(TempD1<-100 && TempK1<-100)
  {
   S=7;
   M=0; 
  }  
// Проверка диапозона температур
// Если температура в кубе меньше Tvoda
 if(S==0)
  {
  if(TempK1 < Tvoda)
   {
    F=0;
    P1=0;
    P2=0;
    B=1;
   }
// Если температура в кубе больше Tvoda но меньше Tvoda2
  if (TempK1 >= Tvoda && Q2==1)
   {
    F=1;
   }
// Если температура в кубе больше Tvoda начинает пищать столько сколько заданов  парметре TS
  nosound();
// Если температура в кубе больше Tvoda, а крепость погона больше Kstop и выбрано окончание по крепости
   if (TempK1 >= Tvoda && K2 > Kstop && A==1 && Q2==0) 
    {
     F=2;
     if (P1==0)
      {
       B=1;
       P1=1;
      }
     }
// Если температура в кубе больше Tstop и выбрано окончание по Ткуба
   if (TempK1 >= Tstop && A==0)
    {
     F=3;
     if (P2==0)
      {
       B=1;
       P2=1;
      }
     }
//Если крепость погона меньше Kstop и выбрано окончание по крепости и Ткуба больше Tvoda    
    if (K2 <= Kstop && A==1 && TempK1 >= Tvoda)
     {
      F=3;
       if (P2==0)
        {
         B=1;
         P2=1;
        }
      }
  }    
   switch(S)
    {
// Основной экран   
     case 0:
// Если звук включен и нажать вниз, то звук выключится     
      if(Y>600 && B==1)                            // Джойстик вниз
       {
        B=0;
       }
// Если звук выключен и нажать вверх, то звук включится         
      if(Y<400 && B==0)                            // Джойстик вверх
       {
        B=1;
       }
        LCD(); 
        lcd.createChar(2, sound);
        lcd.createChar(3, soundon);
        lcd.createChar(4, soundoff);
// Информация на экране если звук включен
        LCD();
        lcd.print("K "); 
        lcd.print(TempK1,1); 
        lcd.print("\1 KP ");
        lcd.print(K1,0);
        lcd.print("%");
        lcd.setCursor(14, 0);
        if(B==1)                //звук включен
         {
          lcd.print("\2\3");
         }
        else                //звук выключен
         {
          lcd.print("\2\4");
         } 
        lcd.setCursor(0, 1); 
        lcd.print("D ");
        lcd.print(TempD3,1);
        lcd.print("\1 KP ");
        lcd.print(K2,0);
        lcd.print("%");
        lcd.setCursor(15, 1);
        lcd.print(F);
        if(F==1 && B==1)
         {
          tone(7, 700, 700);
         }
        if(F==3 && B==1)
         {
          tone(7, 700, 700);
         }
     break;
     
// Второй экран с дополнительной информацией
     case 1:
      LCD();
      lcd.print("P:");
      lcd.print(Pr,0);
      lcd.print("mm dP:");
      lcd.print(dP,0);
      lcd.print("mm");
      lcd.setCursor(0, 1);
      lcd.print("T:");
      lcd.print(Tp,1);
      lcd.print("\1 dT:");
      lcd.print(dT,2);
      lcd.print("\1");
      exit();
     break;
      
// Третий экран входа в меню 
     case 2:
     if(M==0)
      {
       LCD();
       lcd.setCursor(6, 0);
       lcd.print("MENU");
       lcd.setCursor(0, 1);
       lcd.print(" click to enter");
       exit();
      }
// Нажав кнопку на джойстике попадаем в меню 
      if (Z==1 && M==0)
       {
        M=1;
        Z=0;
       }
      break;
      
// Экран при замыкании датчика приемной емкости      
      case 3:
       LCD();
       lcd.print("cMeHuTe EMkoCTb");
       tone(7, 700, 350);
       S=0;
      break; 
      
// Экран при замыкании датчика разлития воды            
      case 4: 
       LCD();      
       lcd.print("ALARM BODA");
       tone(7, 700, 350);
       S=0;
      break;   
     
// Экран при отвалившемся датчике температуры куба            
      case 5: 
       LCD();      
       lcd.print("npoBepb DaT4uk");
       lcd.setCursor(0, 1);
       lcd.print("Tky6a");
       tone(7, 700, 350);
       S=0;
      break;   
     
// Экран при отвалившемся датчике температуры дистиллятора                       
      case 6: 
       LCD();      
       lcd.print("npoBepb DaT4uk");
       lcd.setCursor(0, 1);
       lcd.print("TeMn DucT");
       tone(7, 700, 350);
       S=0;
      break;   
     
// Экран при отвалившихся обоих датчиках                           
      case 7: 
       LCD();      
       lcd.print("npoBepb DaT4uku");
       lcd.setCursor(0, 1);
       lcd.print("TeMnepaTypbI");
       tone(7, 700, 350);
       S=0;
      break;   
     }
// МЕНЮ редактирования
    if(M==1)
     {
      LCD();
      lcd.createChar(5, up);
      lcd.createChar(7, down);
      if(X < 400 && R==0)
     {
      P=P-1;
      if (P<0)
       {
        P=21;
        }
       }
       if(X > 600 && R==0)
        {
         P=P+1;
         if (P>21)
          {
           P=0;
          }
         }
      switch(P)
       {
// Первая страница меню
        case 0:
         LCD();
         lcd.print("Menu edit <- ->");
         if (Z==1)
          {
           M=0;
           Z=0;
          }
          exit();
        break;
        
// Редактируем параметр Tvoda 
        case 1:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=Tvoda;
           }
          if (R==1)
           {
            edit1();
            if(dT0>=Tstop)
             {
               dT0=Tstop;
             }
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=Tvoda)
               {
                Tvoda=dT0;
                EEFW(0, Tvoda);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("Tvoda ");
           if(R==0)
            {
             lcd.print(Tvoda,1);
            }
           else
            { 
             ekran();
            }
          break;
          

          
// Редактируем параметр Tstop
        case 2:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=Tstop;
           }
          if (R==1)
           {
            edit1();
            if(dT0<=Tvoda)
             {
               dT0=Tvoda;
             }
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=Tstop)
               {
                Tstop=dT0;
                EEFW(8, Tstop);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("Tstop ");
           if(R==0)
            {
             lcd.print(Tstop,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр Kstop
        case 3:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dC=Kstop;
           }
          if (R==1)
           {
            if(Y < 400)
             {
              dC=dC+1;
              if(dC >= Kstopmax)
               {
                dC=Kstopmax;
               }
              }
             if(Y > 600)
              {
               dC=dC-1;
               if(dC <= Kstopmin)
                {
                 dC=Kstopmin;
                }
               }
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dC!=Kstop)
               {
                Kstop=dC;
                EEPROM.write(68, Kstop);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("Kstop ");
           if(R==0)
            {
             lcd.print(Kstop,0);
             lcd.print("%");
            }
           else
            { 
             lcd.print(dC);
             lcd.print("%");
             lcd.setCursor(0, 1);
             lcd.print("edit \5\7");
            }
           break;
           
// Редактируем параметр TS - время писка при достижении Tvoda
        case 4:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dC=TS;
           }
          if (R==1)
           {
            if(Y < 400)
             {
              dC=dC+5;
              if(dC >= 250)
             {
              dC=250;
             }
           }
        if(Y > 600)
         {
          dC=dC-5;
          if(dC <= 10)
           {
            dC=10;
            }
           }
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dC!=TS)
               {
                TS=dC;
                EEPROM.write(4, TS);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("TS ");
           if(R==0)
            {
             lcd.print(TS);
             lcd.print(" cek");
            }
           else
            { 
             lcd.print(dC);
             lcd.print(" cek");
             lcd.setCursor(0, 1);
             lcd.print("edit \5\7");
            }
          break;
          
// Редактируем параметр E (использовать ли датчик в приемной емкости)
        case 5:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dC=E;
           }
          if (R==1)
           {
            edit3();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dC!=E)
               {
                E=dC;
                EEPROM.write(69, E);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("DaT4uk eMkocTu ");
           if(R==0)
            {
             if(E==0)
              {
               lcd.print("-");
              }
             else
              {
               lcd.print("+");
              }
             }
            else
             {
               if(dC==0)
                {
                 lcd.print("-");
                }
               else
                {
                 lcd.print("+");
                }
              }
           lcd.setCursor(0, 1);
           if(R==1)
            {
             lcd.print("edit \5\7");
            }
          break;
          
// Редактируем параметр W (использовать ли датчик разлития воды)
        case 6:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dC=W;
           }
          if (R==1)
           {
            edit3();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dC!=W)
               {
                W=dC;
                EEPROM.write(70, W);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("DaT4uk BoDbI ");
           if(R==0)
            {
             if(W==0)
              {
               lcd.print("-");
              }
             else
              {
               lcd.print("+");
              }
             }
            else
             {
               if(dC==0)
                {
                 lcd.print("-");
                }
               else
                {
                 lcd.print("+");
                }
              }
           lcd.setCursor(0, 1);
           if(R==1)
            {
             lcd.print("edit \5\7");
            }
          break;
         
// Редактируем параметр A (как заканчивать отбор - по Ткуба или по крепости погона)
        case 7:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dC=A;
           }
          if (R==1)
           {
            edit3();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dC!=A)
               {
                A=dC;
                EEPROM.write(71, A);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("cTon no ");
           if(R==0)
            {
             if(A==0)
              {
               lcd.print("Tkyba");
              }
             else
              {
               lcd.print("kpenocTu");
              }
             }
            else
             {
               if(dC==0)
                {
                 lcd.print("Tkyba");
                }
               else
                {
                 lcd.print("kpenocTu");
                }
              }
           lcd.setCursor(0, 1);
           if(R==1)
            {
             lcd.print("edit \5\7");
            }
          break;
         
// Редактируем параметр dTD78_81(поправку на диапозоне 78-81*С)
        case 8:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD78_81;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD78_81)
               {
                dTD78_81=dT0;
                EEFW(12, dTD78_81);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD78_81 ");
           if(R==0)
            {
             lcd.print(dTD78_81,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр dTD81_84(поправку на диапозоне 81-84*С)
        case 9:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD81_84;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD81_84)
               {
                dTD81_84=dT0;
                EEFW(16, dTD81_84);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD81_84 ");
           if(R==0)
            {
             lcd.print(dTD81_84,1);
            }
           else
            { 
             ekran();
            }
          break; 
          
// Редактируем параметр dTD84_87(поправку на диапозоне 84-87*С)
        case 10:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD84_87;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD84_87)
               {
                dTD84_87=dT0;
                EEFW(20, dTD84_87);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD84_87 ");
           if(R==0)
            {
             lcd.print(dTD84_87,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр dTD87_90(поправку на диапозоне 87-90*С)
        case 11:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD87_90;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD87_90)
               {
                dTD87_90=dT0;
                EEFW(24, dTD87_90);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD87_90 ");
           if(R==0)
            {
             lcd.print(dTD87_90,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр dTD90_91(поправку на диапозоне 90-91*С)
        case 12:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD90_91;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD90_91)
               {
                dTD90_91=dT0;
                EEFW(28, dTD90_91);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD90_91 ");
           if(R==0)
            {
             lcd.print(dTD90_91,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр dTD91_92(поправку на диапозоне 91-92*С)
        case 13:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD91_92;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD91_92)
               {
                dTD91_92=dT0;
                EEFW(32, dTD91_92);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD91_92 ");
           if(R==0)
            {
             lcd.print(dTD91_92,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр dTD92_93(поправку на диапозоне 92-93*С)
        case 14:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD92_93;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD92_93)
               {
                dTD92_93=dT0;
                EEFW(36, dTD92_93);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD92_93 ");
           if(R==0)
            {
             lcd.print(dTD92_93,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр dTD93_94(поправку на диапозоне 93-94*С)
        case 15:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD93_94;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD93_94)
               {
                dTD93_94=dT0;
                EEFW(40, dTD93_94);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD93_94 ");
           if(R==0)
            {
             lcd.print(dTD93_94,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр dTD94_95(поправку на диапозоне 94-95*С)
        case 16:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD94_95;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD94_95)
               {
                dTD94_95=dT0;
                EEFW(44, dTD94_95);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD94_95 ");
           if(R==0)
            {
             lcd.print(dTD94_95,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр dTD95_96(поправку на диапозоне 95-96*С)
        case 17:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD95_96;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD95_96)
               {
                dTD95_96=dT0;
                EEFW(48, dTD95_96);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD95_96 ");
           if(R==0)
            {
             lcd.print(dTD95_96,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр dTD96_97(поправку на диапозоне 96-97*С)
        case 18:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD96_97;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD96_97)
               {
                dTD96_97=dT0;
                EEFW(52, dTD96_97);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD96_97 ");
           if(R==0)
            {
             lcd.print(dTD96_97,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр dTD97_98(поправку на диапозоне 97-98*С)
        case 19:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD97_98;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD97_98)
               {
                dTD97_98=dT0;
                EEFW(56, dTD97_98);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD97_98 ");
           if(R==0)
            {
             lcd.print(dTD97_98,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр dTD98_99(поправку на диапозоне 98-99*С)
        case 20:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD98_99;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD98_99)
               {
                dTD98_99=dT0;
                EEFW(60, dTD98_99);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD98_99 ");
           if(R==0)
            {
             lcd.print(dTD98_99,1);
            }
           else
            { 
             ekran();
            }
          break;
          
// Редактируем параметр dTD99_100(поправку на диапозоне 99-100*С)
        case 21:
         if (Z==1 &&  R==0)
          {
           R=1;
           Z=0;
           dT0=dTD99_100;
           }
          if (R==1)
           {
            edit2();
            if(Z==1)
             {
              R=0;
              Z=0;
              if(dT0!=dTD99_100)
               {
                dTD99_100=dT0;
                EEFW(64, dTD99_100);
               }
             }  
           }
           exit();
// Вывод на экран информации о редактировании переменной           
           LCD();
           lcd.print("dTD99_100 ");
           if(R==0)
            {
             lcd.print(dTD99_100,1);
            }
           else
            { 
             ekran();
            }
          break;
         }
      }
//   delay(200);
 }

